function [Motion,x1_ds_x2]= EstimateMotion1D(vrai_x1,x1, x2, affichage)



t_begin = cputime;

% x1: 1-D signal

% x2: X1 displaced by "Motion" units

N=length(x1);

if (size(x1)~=size(x2))

   disp('X1 and X2 are not of the same size!');

end



X1C = DctI_1D(x1);		% Equation 6

X1S = DstI_1D(x1);		% Equation 7

X2C = DctII_1D(x2);		% Equation 4

X2S = DstII_1D(x2);		% Equation 5 



% Initialisation des variables

X2 = zeros(2,1,(N+1));

X1 = zeros(2,2,(N+1));

k = zeros((N+1),1);

Theta = zeros(2,1,(N+1));

C = ones((N+1),1);

Gms = zeros((N+1),1);



% Construction de X2 (Matrice 3-D)

X2(1,1,:) = X2C;

X2(2,1,:) = X2S;



% Construction de X1 (Matrice 3-D)

X1(1,1,:) = X1C;

X1(1,2,:) = -X1S;

X1(2,1,:) = X1S;

X1(2,2,:) = X1C;



for I=1:length(X1)					% k de l'equation 10

   temp=det(X1(:,:,I));
   if temp==0
        k(I)=1;
   else
        k(I)=1/temp;
    end;

end



for I=1:length(X1)					% Equation 10

   Theta(:,:,I) = k(I)*X1(:,:,I)'*X2(:,:,I);

end



C(1) = 1/sqrt(2);

C(N+1) = 1/sqrt(2);



for I=1:length(x1)

   Gms(I)=Theta(2,1,I);

end



M = IDstII_1D(C.*Gms);				% Equation 13
plot(M);

MaxIndex = find(abs(M)==max(abs(M)));



if (M(MaxIndex) < 0)					% Equation 20

   Motion = -((MaxIndex-1) + 1);	% (MaxIndex-1) parce

else 										% que Index 1 du

   Motion = (MaxIndex-1);			% vecteur correspond

end										% a n=0 



% show results

if (affichage)

	t=linspace(0,N-1,N);

   t1=linspace(0,N,N+1);

   

   %display signal x1 and x2

    fig1=figure(1);

    suptitle(['Deplacement = ' num2str(Motion)]);

    subplot(4,2,1);

    plot(t,x1);

    title('X1');

    subplot(4,2,2);

    plot(t,x2);

    title('X2');



    % display DST and DST   

    subplot(4,2,3);

    plot(t1,X1C);

    title('DCTI X1');

    subplot(4,2,4);

    plot(t1,X1S);

    title('DSTI X1');

    subplot(4,2,5);

    plot(t1,X2C);

    title('DCT X2');

    subplot(4,2,6);

    plot(t1,X2S);

    title('DST X2');



    % display PseudoPhase freq

    subplot(4,2,7);

    plot(t1,Gms);

    title('PseudoPhase freq');

    % display PseudoPhase spatial

    subplot(4,2,8);

    t=linspace(0,N-1,N);

    plot(t,M);

    title('PseudoPhase spacial');



    t_end = cputime;

    disp(['Time to execute = ' num2str(t_end-t_begin) ' sec']);

 end

 disp(['Deplacement (MotionEstimation) = ' num2str(Motion)]);
 
 [max index] = max(M);
 x2_inv=x2';
 x1_ds_x2=zeros(size(x1));
 x1_ds_x2=x2_inv(1,index:index+length(vrai_x1)-1);

 