function [MotionX, MotionY] = EstimateMotion(Image1, Image2, BlockSize, TEST_BOUCLE)

if (size(Image1) ~= size(Image2))
   disp('Erreur: Les images ne sont pas de la mme taille!');
   return;
end

% ImageSize est une matrice de deux lments:
%   Premier lment: Nombre de pixels sur l'axe vertical
%   Deuxime lment: Nombre de pixels sur l'axe horizontal
[y,x] = size(Image1);

if ((mod(y,BlockSize) ~= 0) | (mod(x,BlockSize) ~= 0))
   disp('Erreur: Les images ne peuvent tre divises en un nombre naturel de blocs!');
   return;
end

NbrBlockY = y/BlockSize;
NbrBlockX = x/BlockSize;
NbrBlocks = NbrBlockX * NbrBlockY;
disp(['NbrBlockY ',num2str(NbrBlockY),' NbrBlockX : ',num2str(NbrBlockX)]);
%MotionVectors = zeros((NbrBlockX*NbrBlockY),2);
MotionX = zeros(NbrBlockY,NbrBlockX);
MotionY = zeros(NbrBlockY,NbrBlockX);

if TEST_BOUCLE == 0
   for I=1:NbrBlockY
      for J=1:NbrBlockX
         BlockNumber = ((I-1) * NbrBlockX) + J;
         disp(['Bloc ', int2str(BlockNumber), ' de ', int2str(NbrBlocks)]);
         LowLimitY = ((I-1) * BlockSize) + 1;
         HighLimitY = I * BlockSize;
         LowLimitX = ((J-1) * BlockSize) + 1;
         HighLimitX = J * BlockSize;

         Block1 = Image1(LowLimitY:HighLimitY , LowLimitX:HighLimitX);
         Block2 = Image2(LowLimitY:HighLimitY , LowLimitX:HighLimitX);
      
         %[MotionVectors(BlockNumber, 1),MotionVectors(BlockNumber, 2)] = ...
         %   EstimateBlockMotion(Block1, Block2);
         [MotionX(I,J),MotionY(I,J)] = ...
            EstimateBlockMotion(Block1, Block2);
      end
   end
end
