function X_IDCSTII_2D = IDcstII_2D(X)

% Cette fonction retourne l'inverse de la DCST de type II de X

[N, M] = size(X);

if (M~=N)
   disp('IDcstII_2D: L''argument doit tre une matrice carree.');
   return;
end
N=N-1;			% L'image a un point de moins que la transforme

X_IDCSTII_2D = zeros(N,N);
C = ones((N+1),1);
C(1) = 1/sqrt(2);
C(N+1) = 1/sqrt(2);

for m=1:N													%Equation 41
   for n=1:N
      for k=1:N
			for l=2:(N+1)
            X_IDCSTII_2D(n,m)=...
               X_IDCSTII_2D(n,m)+...
               4/N^2*C(k)*C(l)*X(l,k)*...
               cos((k-1)*pi/N*((m-1)+0.5))*...
               sin((l-1)*pi/N*((n-1)+0.5));
         end
      end
   end
end
